-----------------------------------------------------------------------------------------
-- Start Activity
-----------------------------------------------------------------------------------------
function BlockWars:StartActivity()
	if self.IsInitialized == nil then
		self.IsInitialized = false
	end

	if self.IsInitialized then 
		return
	end

	-- If you are a developer you can turn on/off almost all of
	-- this mission's debug yada-yada with this flag
	self.Debug = false; --true;
	self.DrawWaypoints = false; --true;
	
   	print("START! -- BlockWarsGameplay:StartActivity()!");

	self.ModuleName = "BlockWars.rte";
	
	CF_InitFactions(self.ModuleName)
	
	config = CF_ReadConfigFile(self.ModuleName , "Factions.dat")

	if self.Debug then 
		print(config) 

		for i,line in pairs(config) do
			print(tostring(i).."="..tostring(line));
		end
	end
	
	CF_PlayerFaction = config["PlayerFaction"]
	CF_CPUFaction = config["CPUFaction"]
	
	-- self.SweepZone = SceneMan.Scene:GetArea("SweepZone"); -- Zone to clear out of enemies
    self.FightPhase = { NOFIGHT = 0};
    self.CurrentFightPhase = self.FightPhase.NOFIGHT;

	self.BrainhuntPercentage = 0.20; -- Amount of defenders that will be sent to hunt for enemy brain.

	self.braindead = {};
	self.AssignedBrains = {};

	self.MOIDLimit = 220;
    self.GenericTimer = Timer();
	
   	-- Set up teams
   	-- Team 2 is always CPU
	self.PlayerTeam = Activity.TEAM_1;
   	self.CPUTeam = Activity.TEAM_2;
	self.RogueTeam = -1;

	-- Send troops to specific not more than 1 unit\14	 secs
	self.DispatchInterval = 20000;
	
	-- Every once in a while all actors start searching for brainz
	self.RageInterval = 90000;
    self.RageTimer = Timer();


	-- Init team megastructures
	self.T = {}

	for team = 0, 1 do
		self.T[team] = {};
		self.T[team].SpawnTimer = Timer();
		self.T[team].SpawnTimer:Reset();
		self.T[team].SpawnInterval = 6500;
		self.T[team].SpawnCoeff = 1.0;
		
		
		self.T[team].Chamber = SceneMan.Scene:GetArea("Chamber-"..team + 1);
		self.T[team].BrainRoom = SceneMan.Scene:GetArea("BrainRoom-"..team + 1);

		self.T[team].Hall = SceneMan.Scene:GetArea("Hall-"..team + 1);
		self.T[team].HallDef = SceneMan.Scene:GetArea("HallDef-"..team + 1);

		self.T[team].ChamberEmpty = true;
		self.T[team].HallEmpty = true;
		self.T[team].ChamberEmptyLastTime = true;
		self.T[team].Dispatch = SceneMan.Scene:GetArea("Dispatch-"..team + 1);
		self.T[team].Brain = SceneMan.Scene:GetArea("Brain-"..team + 1);
		self.T[team].Spawn = SceneMan.Scene:GetArea("Spawn-"..team + 1);
		
		self.T[team].Def = {};
		self.T[team].Waypoint = {};
		self.T[team].DefEmpty = {};
		self.T[team].LastDispatch = {};
		
		for defence = 1, 6 do
			self.T[team].Def[defence] = SceneMan.Scene:GetArea("Defence-"..(team + 1).."-"..defence);
			self.T[team].DefEmpty[defence] = true;
			self.T[team].LastDispatch[defence] = -(self.DispatchInterval * 2);
		end

		for defence = 1, 5 do
			self.T[team].Waypoint[defence] = SceneMan.Scene:GetArea("Waypoint-"..(team + 1).."-"..defence);
		end
		
		self.TroopsCount = 0;
	end

	self.T[self.PlayerTeam].Faction = CF_PlayerFaction;
	self.T[self.CPUTeam].Faction = CF_CPUFaction;
	

	-- Decision making or usefull stats
	self.UnitCount = 0;

	--self.CPUBrain = CreateAHuman("Brain Robot" , "Base.rqte");
	self.CPUBrain = CreateActor("Brain Case" , "Base.rte");
	self.CPUBrain.Team = self.CPUTeam;
	self.CPUBrain.Pos = self.T[self.CPUTeam].Brain:GetCenterPoint();
	self.CPUBrain.AIMode = Actor.AIMODE_SENTRY;
	self.CPUBrainDead = false;
	
	--[[wpn = CF_MakeWeapon(self.T[self.CPUTeam].Faction , true)
	if wpn ~= nil then
		self.CPUBrain:AddInventoryItem(wpn);
	end
	wpn = CF_MakeWeapon(self.T[self.CPUTeam].Faction , true)
	if wpn ~= nil then
		self.CPUBrain:AddInventoryItem(wpn);
	end]]--
	MovableMan:AddActor(self.CPUBrain);
    
   	for player = 0, self.PlayerCount - 1 do
		-- Check if we already have a brain assigned
		if not self:GetPlayerBrain(player) then
			-- Set up players
			self.braindead[player] = false;
			--local brain = CreateAHuman("Brain Robot" , "Base.rte");
			local brain = CreateActor("Brain Case" , "Base.rte");
			--[[wpn = CF_MakeWeapon(self.T[self.PlayerTeam].Faction , true)
			if wpn ~= nil then
				brain:AddInventoryItem(wpn);
			end
			wpn = CF_MakeWeapon(self.T[self.PlayerTeam].Faction , true)
			if wpn ~= nil then
				brain:AddInventoryItem(wpn);
			end]]--
			brain.Team = self.PlayerTeam;
			brain.AIMode = Actor.AIMODE_SENTRY;
			brain.Pos = self.T[self.PlayerTeam].Brain:GetCenterPoint();
			MovableMan:AddActor(brain);
			self.AssignedBrains[player] = brain;

			-- Set the found brain to be the selected actor at start
			self:SetPlayerBrain(brain, player);
			
			-- Set the observation target to the brain, so that if/when it dies, the view flies to it in observation mode
			self:SetObservationTarget(self:GetPlayerBrain(player).Pos, player)
		end --if
	end --for

	CF_ReplaceActors(config , MovableMan.AddedActors)
	CF_ReplaceActors(config , MovableMan.Actors)
	
    -- Set up AI modes for the Actors that have been added to the scene by the scene definition
    for actor in MovableMan.AddedActors do
		actor.AIMode = Actor.AIMODE_SENTRY;
    end

    -- Set the team's funds.
    self:SetTeamFunds(0 , self.PlayerTeam);

    -- Reset all timers
	self.GenericTimer:Reset();
	self.RageTimer:Reset();
	
	self.IsInitialized = true
end

-----------------------------------------------------------------------------------------
-- Pause Activity
-----------------------------------------------------------------------------------------
function BlockWars:PauseActivity(pause)
    print("PAUSE! -- DummyAssault:PauseActivity()!");
end

-----------------------------------------------------------------------------------------
-- End Activity
-----------------------------------------------------------------------------------------
function BlockWars:EndActivity()
    print("END! -- DummyAssault:EndActivity()!");
end
-----------------------------------------------------------------------------------------
-- Brain selection and gameover conditions check
-----------------------------------------------------------------------------------------
function BlockWars:DoBrainSelection()
	if not (self.ActivityState == Activity.OVER) then
		-- Iterate through all human players
		for player = 0, self.PlayerCount - 1 do
			-- The current player's team
			local team = self:GetTeamOfPlayer(player);
	
			-- Make sure the game is not already ending
			-- Check if any player's brain is dead
			local brain = self:GetPlayerBrain(player);
			if not brain or not MovableMan:IsActor(brain) or not brain:HasObjectInGroup("Brains") then
				self:SetPlayerBrain(nil, player);
				-- Try to find a new unasigned brain this player can use instead, or if his old brain entered a craft
				local newBrain = MovableMan:GetUnassignedBrain(team);
				-- Found new brain actor, assign it and keep on truckin'
				if newBrain and self.braindead[player] == false then
					self:SetPlayerBrain(newBrain, player);
					self.AssignedBrains[player] = newBrain;
					self:SwitchToActor(newBrain, player, team);
				else
					FrameMan:SetScreenText("Commander died!", player, 333, -1, false);
					self.braindead[player] = true;
					
					-- Now see if all brains of self player's team are dead, and if so, end the game
					--if not MovableMan:GetClosestBrainActor(team) then
					self.WinnerTeam = self:OtherTeam(team);
					ActivityMan:EndActivity();
					--end
				end
			else
				-- Update the observation target to the brain, so that if/when it dies, the view flies to it in observation mode
				self:SetObservationTarget(brain.Pos, player)
			end -- 
		end --for
	end
end
-----------------------------------------------------------------------------------------
-- Spawn troops
-----------------------------------------------------------------------------------------
function BlockWars:Spawn(team , custompos)
	for i = 1, math.random(3) do
		if MovableMan:GetMOIDCount() < self.MOIDLimit then
			if math.random() < 0.05 then
				CF_SpawnArmor(team , custompos , self.T[team].Faction , Actor.AIMODE_SENTRY)
			else
				CF_SpawnRandomInfantry(team , custompos , self.T[team].Faction , Actor.AIMODE_SENTRY)
			end
		end
	end
end
-----------------------------------------------------------------------------------------
-- Update Activity
-----------------------------------------------------------------------------------------
function BlockWars:UpdateActivity()
	-- Just check for intialization flags in update loop to avoid unnecessary function calls during all the mission
	if self.IsInitialized == nil then
		self.IsInitialized = false
	end
	
	if not self.IsInitialized then
		--Init mission if we're still not
		self:StartActivity()
	end	
	
   	-- Clear all objective markers, they get re-added each frame
   	self:ClearObjectivePoints();
   	
   	self:DoBrainSelection();
	self:UpdateBaseDefenceStats(); -- This MUST be called before any CPU decision making routines
	self:DispatchTroops(); -- This MUST be called before any CPU decision making routines

	for team = 0, 1 do
		if self.T[team].SpawnTimer:IsPastSimMS(self.T[team].SpawnInterval * self.T[team].SpawnCoeff) then
			if not self.CPUBrainDead then
				self:Spawn(team , self.T[team].Spawn:GetCenterPoint());
				self.T[team].SpawnTimer:Reset();
			end
		end
	end

	-- Periodically start rage to avoid cluttering
	if self.RageTimer:IsPastSimMS(self.RageInterval) then
		self.RageTimer:Reset();
		self.RageInterval = 30000 + (-10000 + math.random(20000));
		self:StartRage();
	end
	
	if not self.GenericTimer:IsPastSimMS(10000) then
		--Mark commander on start to warn player
		for player = 0, self.PlayerCount - 1 do
			if MovableMan:IsActor(self.AssignedBrains[player]) then
				if self.AssignedBrains[player]:HasObjectInGroup("Brains") then
					self:AddObjectivePoint("Protect commander!", self.AssignedBrains[player].AboveHUDPos, self.PlayerTeam, GameActivity.ARROWDOWN);
				end
			end -- if
		end -- for
	end
	self:CheckWinningConditions();
	self:YSortObjectivePoints();
end
-----------------------------------------------------------------------------------------
-- Update base defence stats to make dispatch decisions later
-----------------------------------------------------------------------------------------
function BlockWars:UpdateBaseDefenceStats()
	self.UnitCount = 0;

	-- Reset stats
	for team = 0 , 1 do
		for defence = 1, 6 do
			self.T[team].DefEmpty[defence] = true;
		end
		self.T[team].ChamberEmpty = true;
		self.T[team].HallEmpty = true;
		self.T[team].Count = 0;
	end
	
	-- Update stats
	for actor in MovableMan.Actors do
		for team = 0 , 1 do
			if actor.Team == team then
				for defence = 1, 6 do
					if self.T[team].Def[defence]:IsInside(actor.Pos) then
						self.T[team].DefEmpty[defence] = false;
					end
				end

				self.T[team].Count = self.T[team].Count + 1;
			else
				if self.T[team].Chamber:IsInside(actor.Pos) then
					self.T[team].ChamberEmpty = false;
				end

				if self.T[team].Hall:IsInside(actor.Pos) then
					self.T[team].HallEmpty = false;
				end
			end
		end
	end
	
	for team = 0 , 1 do
		-- If enemies entered chamber send all for defence
		if self.T[team].ChamberEmpty == false then
			if self.T[team].ChamberEmptyLastTime == true then
				if self.Debug then
					print ("Chamber alert!!!");
				end
				for actor in MovableMan.Actors do
					if actor.Team == team and actor.PresetName ~= "Brain Case" then
						if actor.AIMODE ~= Actor.AIMODE_BRAINHUNT then
							self:AssignToBrainDefence(actor , team);
						end
					end
				end
			end
		else
			-- If enemies left chamber - revenge
			if self.T[team].ChamberEmptyLastTime == false then
				if self.Debug then
					print ("Revenge!!!");
				end
				for actor in MovableMan.Actors do
					if actor.Team == team and actor.PresetName ~= "Brain Case" then
						actor.AIMode = Actor.AIMODE_BRAINHUNT;
					end
				end
			end
		end

		-- Enforce spawn for team under siege
		if self.T[team].ChamberEmpty == false then
			self.T[team].SpawnCoeff = 0.5;
		else 
			self.T[team].SpawnCoeff = 1.0;
		end
		
		-- Reset chamber flags
		self.T[team].ChamberEmptyLastTime = self.T[team].ChamberEmpty;
	end

	-- Balance spawn depending on unit count
	if (self.T[self.PlayerTeam].Count > self.T[self.CPUTeam].Count) then
		self.T[self.PlayerTeam].SpawnCoeff = self.T[self.PlayerTeam].SpawnCoeff + 0.25;
	else
		self.T[self.CPUTeam].SpawnCoeff = self.T[self.CPUTeam].SpawnCoeff + 0.25;
	end
end
---------------------------------------------------------------------
-- Print base defence stats to debug dispatch decisions
-----------------------------------------------------------------------------------------
function BlockWars:PrintBaseDefenceStats()
	if not self.Debug then 
		return;
	end

	for team = 0 , 1 do
		local out;
		out = "";
		for defence = 1, 6 do
			if self.T[team].DefEmpty[defence] == false then
				out = out .. "X";
			else
				out = out .. "0";
			end
		end
	
		if self.T[team].ChamberEmpty == false then
			out = out .. "--X";
		else
			out = out .. "--0";
		end

		if self.T[team].HallEmpty == false then
			out = out .. "--X";
		else
			out = out .. "--0";
		end
		
		-- Print unit count and spawn rate coefficient`
		out = out.." ("..tostring(self.T[team].Count)..")  ("..tostring(self.T[team].SpawnCoeff)..")";
		print ("STAT: "..tostring(team).." "..out);
	end
end
---------------------------------------------------------------------
-- Update base defence stats to make dispatch decisions later
-----------------------------------------------------------------------------------------
function BlockWars:DispatchTroops()
	for actor in MovableMan.Actors do
		for team = 0 , 1 do
			if actor.Team == team then
				local assigned = false;
			
				-- Send troops to brain chamber
				-- Chamber uber alles
				if self.T[team].ChamberEmpty == false then
					if actor.AIMode ~= Actor.AIMODE_BRAINHUNT and actor.AIMode ~= Actor.AIMODE_GOTO and actor.PresetName ~= "Brain Case" then
						self:AssignToBrainDefence(actor , team);
						if self.T[team].Dispatch:IsInside(actor.Pos) then
							actor:FlashWhite(150);
						end
					end
				else
					-- Hall is important too
					if self.T[team].HallEmpty == false then
						if actor.AIMode ~= Actor.AIMODE_BRAINHUNT and actor.AIMode ~= Actor.AIMODE_GOTO and actor.PresetName ~= "Brain Case" then
							self:AssignToHallDefence(actor , team);
							if self.T[team].Dispatch:IsInside(actor.Pos) then
								actor:FlashWhite(150);
							end
						end
					else
						if (actor.AIMode == Actor.AIMODE_SENTRY) and self.T[team].Dispatch:IsInside(actor.Pos) then
							for defence = 6, 1, -1 do
								if self.T[team].DefEmpty[defence] == true then
									if self.GenericTimer.ElapsedSimTimeMS > self.T[team].LastDispatch[defence] + self.DispatchInterval then
										self:AssignToPoint(actor , team , defence);
										actor:FlashWhite(150);
										assigned = true;
										break;
									end -- if
								end -- if
							end -- for
							-- No empty points? Brainhunt!
							if assigned == false then
								if self.Debug then
									print ("ASSIGN: "..tostring(actor).." T:"..tostring(team).." Brainhunt");
								end
								actor:ClearAIWaypoints();
								actor.AIMode = Actor.AIMODE_BRAINHUNT;
								actor:FlashWhite(150);
							end --if
						end -- if
					end --if-else
				end --if
			end -- if
		end -- for
	end --for 
end -- func
-----------------------------------------------------------------------------------------
-- 
-----------------------------------------------------------------------------------------
function BlockWars:StartRage()
	print ("RAGE TIME!!!");
	for actor in MovableMan.Actors do
		if actor.PresetName ~= "Brain Case" then
			actor:ClearAIWaypoints();
			actor.AIMode = Actor.AIMODE_BRAINHUNT;
		end
	end
end
-----------------------------------------------------------------------------------------
-- 
-----------------------------------------------------------------------------------------
function BlockWars:AssignToHallDefence(act , team )
	if self.Debug then
		print ("ASSIGN:"..tostring(act).." T:"..tostring(team).." Hall");
	end
	act.AIMode = Actor.AIMODE_GOTO;
	act:ClearAIWaypoints();
	act:AddAISceneWaypoint(self.T[team].HallDef:GetCenterPoint());

	if self.DrawWaypoints then
		act:DrawWaypoints(true);
	end
	
	self:PrintBaseDefenceStats();
end
-----------------------------------------------------------------------------------------
-- 
-----------------------------------------------------------------------------------------
function BlockWars:AssignToBrainDefence(act , team )
	if self.Debug then
		print ("ASSIGN:"..tostring(act).." T:"..tostring(team).." Defend");
	end
	act.AIMode = Actor.AIMODE_GOTO;
	act:ClearAIWaypoints();
	act:AddAISceneWaypoint(self.T[team].BrainRoom:GetCenterPoint());

	if self.DrawWaypoints then
		act:DrawWaypoints(true);
	end
	
	self:PrintBaseDefenceStats();
end
-----------------------------------------------------------------------------------------
-- 
-----------------------------------------------------------------------------------------
function BlockWars:AssignToPoint(act , team , pnt)
	if self.Debug then
		print ("ASSIGN: "..tostring(act).." T: "..tostring(team).." @ "..tostring(pnt));
	end
	act.AIMode = Actor.AIMODE_GOTO;
	act:ClearAIWaypoints();
	
	for p = 5 , pnt, -1 do
		act:AddAISceneWaypoint(self.T[team].Waypoint[p]:GetCenterPoint() + Vector(0 , 15));
	end
	act:AddAISceneWaypoint(self.T[team].Def[pnt]:GetCenterPoint() + Vector(0 , 15));	
	self.T[team].LastDispatch[pnt] = self.GenericTimer.ElapsedSimTimeMS;
	
	if self.DrawWaypoints then
		act:DrawWaypoints(true);
	end
	
	self:PrintBaseDefenceStats();
end
-----------------------------------------------------------------------------------------
-- Check if we are victorious
-----------------------------------------------------------------------------------------
function BlockWars:CheckWinningConditions()
	if self.CPUBrainDead == false then
		if not MovableMan:IsActor(self.CPUBrain)then
			print ("Victory");
			-- Team 1 wins!
			self.CPUBrainDead = true;
			self.WinnerTeam = self.PlayerTeam;
			ActivityMan:EndActivity();
			-- Tell the script to stop running for brains as the game has ended.
			for player = 0, self.PlayerCount - 1 do
				self.braindead[player] = true;
			end
		else
			self:AddObjectivePoint("KILL", self.CPUBrain.AboveHUDPos, self.PlayerTeam, GameActivity.ARROWDOWN);
		end
	end
end
-----------------------------------------------------------------------------------------
-- That's all folks!
-----------------------------------------------------------------------------------------
